/*
 * AuswahlFenster.java
 *
 * Created on 04. Jnner 2001, 20:09
 */

/**
 *
 * @author  $Author: tilman $
 * @version $Revision: 1.8 $
 * $Date: 2001/01/13 22:52:47 $
 * $Source: /cvs/java/angabe3/AuswahlFenster.java,v $
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class AuswahlFenster extends Frame implements ActionListener, ItemListener {
/* Diese Klasse definiert das AuswahlFenster */

   /* Deklaration der Listen aus dem AnzeigeFenster */
	private Gemueseartikel lartikel;
	private Gemuesearten larten;
 
    /** Creates new form AuswahlFenster */

    public AuswahlFenster(Gemuesearten arten, Gemueseartikel artikel) {
      initComponents (arten, artikel);
	lartikel = artikel;
	larten = arten;
    }

	/* Fensterelemente */
    private Choice gemueseart;
    private Choice sorte;
    private Button ok;

    private void initComponents (Gemuesearten arten, Gemueseartikel artikel) {

	/* Fenstereinstellungen */
	gemueseart = new Choice ();
      sorte = new Choice ();
      ok = new Button ();

      setLayout (new org.netbeans.lib.awtextra.AbsoluteLayout ());
	setSize(200,200);
      addWindowListener (new WindowAdapter () {
            public void windowClosing (WindowEvent evt) {
                exitForm (evt);
            }
        }
      );

	/* Erstes Choicefeld, wo die Gemseart ausgewhlt werden kann */
      gemueseart.setFont (new Font ("Dialog", 0, 11));
      gemueseart.setName ("Gemueseart");
      gemueseart.setBackground (Color.white);
      gemueseart.setForeground (Color.black);
      gemueseart.addItemListener(this);
      Iterator it = arten.liste.iterator();
	int i = 0;
	while(it.hasNext()) {
	
        	gemueseart.add( ((Gemueseart)it.next()).gname );
		i++;
	}
        add (gemueseart, new org.netbeans.lib.awtextra.AbsoluteConstraints (20, 40, 150, 30));

	/* Zweites Choicefeld, wo die Gemuesesorten zum auswhlen sind */
	  sorte.setFont (new Font ("Dialog", 0, 11));
        sorte.setName ("sorte");
        sorte.setBackground (Color.white);
        sorte.setForeground (Color.black);
	/* sortefuellen setzt die richtigen Items in Abhngigkeit vom 1.
	 * Choicefeld */
	  sortefuellen(gemueseart.getSelectedItem(),artikel);
        add (sorte, new org.netbeans.lib.awtextra.AbsoluteConstraints (20, 80, 150, 30));

	/* OK-Button: */
        ok.setFont (new Font ("Dialog", 0, 11));
        ok.setLabel ("OK");
        ok.setName ("okbutton");
        ok.setBackground (new Color (216, 208, 200));
        ok.setForeground (Color.black);
        ok.addActionListener(this);
	  ok.setActionCommand("ok");

        add (ok, new org.netbeans.lib.awtextra.AbsoluteConstraints (20, 120, 150, 30));

    }
    
    public void actionPerformed(ActionEvent event) {
	/* Methode des ActionListener Interfaces */

	String cmd = event.getActionCommand();
	if (cmd.equals("ok")) {
		if (getTitle().equals("L\u00f6schen")) {
			// Datensatz lschen
			Gemuesesorte loeschobjekt = AnzeigeFenster.artikel.getwithsorte(sorte.getSelectedItem());
			boolean loeschenok = AnzeigeFenster.artikel.liste.remove(loeschobjekt );
			if (loeschenok == false)
				System.out.println("Objekt nicht in der Liste");
		}
		if (getTitle().equals("\u00c4ndern")) {
			// Datensatz ndern
			Gemuesesorte listenobjekt = AnzeigeFenster.artikel.getwithsorte(sorte.getSelectedItem());
			System.out.println(listenobjekt.gname + "wird gendert");
			/* Neues DatenFenster ffnen, und Parameter
			 * setzten */
			DatenFenster aendern = new DatenFenster(larten,listenobjekt);
			aendern.setTitle("\u00c4ndern");
			aendern.gemueseart.select(gemueseart.getSelectedItem());
			aendern.sortenname.setText(sorte.getSelectedItem());
			aendern.artikelcode.setText(listenobjekt.gcode);
			aendern.setVisible(true);
			
		}
		/* Fenster schliessen, und AnzeigeFenster neuzeichnen */
		AnzeigeFenster.can.repaint();
		dispose();
	}
	
    }

    public void itemStateChanged(ItemEvent event) {
    	/* Methode des ItemListeners */
    	sortefuellen(gemueseart.getSelectedItem(),lartikel);
	/* Wenn im Ersten Choice ein Item ausgewhlt wird, wird der
	 * zweite Choice neu berechnet */
    }

    public void sortefuellen(String art, Gemueseartikel artikel) {
    	/* Neuberechnen der zweiten Choice */
    	sorte.removeAll();
      Iterator it = artikel.liste.iterator();
	Gemuesesorte listenobjekt = new Gemuesesorte();
	while(it.hasNext()) {
		listenobjekt = ((Gemuesesorte)it.next());
		if ( listenobjekt.gart.equals(art) )
			sorte.add( listenobjekt.gname);
	}
    }

    /** Exit the Application */

    private void exitForm(WindowEvent evt) {
    	dispose();
    }


    /**
    * @param args the command line arguments
    */

    public static void main (String args[]) {
	/* Alibi main */
		Gemuesearten arten = new Gemuesearten();
        	Gemueseartikel artikel = new Gemueseartikel();
        	new AuswahlFenster (arten,artikel).show ();
    }
}
